Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.amazonaws.services.s3.model
Class BucketVersioningConfiguration

    java.lang.Object
      com.amazonaws.services.s3.model.BucketVersioningConfiguration

    public class BucketVersioningConfiguration

extends Object

Represents the versioning configuration for a bucket.

A bucket's versioning configuration can be in one of three possible states:

- `OFF`
- `ENABLED`
- `SUSPENDED`

By default, new buckets are in the `off` state. Once versioning is enabled for a bucket the status can never be reverted to `off`.

In addition to enabling versioning, a bucket's versioning configuration can also enable Multi-Factor Authentication (MFA) Delete, which restricts the ability to permanently delete a version of an object. When MFA Delete is enabled, only requests from the bucket owner which include an MFA token generated by the hardware authentication device associated with the bucket owner's AWS account can permanently delete an object version. For more information on AWS Multi-Factor Authentication see http://aws.amazon.com/mfa/

The versioning configuration of a bucket has different implications for each operation performed on that bucket or for objects within that bucket. For instance, when versioning is enabled, a PutObject operation creates a unique object version-id for the object being uploaded. The PutObject API guarantees that, if versioning is enabled for a bucket at the time of the request, the new object can only be permanently deleted using the DeleteVersion operation. It can never be overwritten. Additionally, PutObject guarantees that, if versioning is enabled for a bucket the request, no other object will be overwritten by that request. Refer to the documentation sections for each API for information on how versioning status affects the semantics of that particular API.

S3 is eventually consistent. It may take time for the versioning status of a bucket to be propagated throughout the system.

See Also:
  `AmazonS3.getBucketVersioningConfiguration(String)`, `AmazonS3.setBucketVersioningConfiguration(SetBucketVersioningConfigurationRequest)`

Field Summary
`static String` | `ENABLED` S3 bucket versioning status indicating that versioning is enabled for a bucket.
`static String` | `OFF` S3 bucket versioning status indicating that versioning is off for a bucket.
`static String` | `SUSPENDED` S3 bucket versioning status indicating that versioning is suspended for a bucket.

Constructor Summary
`BucketVersioningConfiguration()` Creates a new bucket versioning configuration object which defaults to `OFF` status.
`BucketVersioningConfiguration(String status)` Creates a new bucket versioning configuration object with the specified status.

Method Summary
`String` | `getStatus()` Returns the current status of versioning for this bucket versioning configuration object, indicating if versioning is enabled or not for a bucket.
`Boolean` | `isMfaDeleteEnabled()` Returns true if Multi-Factor Authentication (MFA) Delete is enabled for this bucket versioning configuration, false if it isn't enabled, and null if no information is available about the status of MFADelete.
`void` | `setMfaDeleteEnabled(Boolean b)` Sets the status of Multi-Factor Authentication (MFA) Delete for a bucket.
`void` | `setStatus(String status)` Sets the desired status of versioning for this bucket versioning configuration object.
`BucketVersioningConfiguration` | `withMfaDeleteEnabled(Boolean b)` Sets the status of Multi-Factor Authentication (MFA) Delete for a bucket, and returns this object so that additional method calls may be chained together.
`BucketVersioningConfiguration` | `withStatus(String status)` Sets the desired status of versioning for this bucket versioning configuration object, and returns this object so that additional method calls may be chained together.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### OFF

    public static final String OFF

  S3 bucket versioning status indicating that versioning is off for a bucket. By default, all buckets start off with versioning off. Once you enable versioning for a bucket, you can never set the status back to "Off". You can only suspend versioning on a bucket once you've enabled.

  See Also:
    Constant Field Values

### SUSPENDED

    public static final String SUSPENDED

  S3 bucket versioning status indicating that versioning is suspended for a bucket. Use the "Suspended" status when you want to disable versioning on a bucket that has versioning enabled.

  See Also:
    Constant Field Values

### ENABLED

    public static final String ENABLED

  S3 bucket versioning status indicating that versioning is enabled for a bucket.

  See Also:
    Constant Field Values

Constructor Detail

### BucketVersioningConfiguration

    public BucketVersioningConfiguration()

  Creates a new bucket versioning configuration object which defaults to `OFF` status.

### BucketVersioningConfiguration

    public BucketVersioningConfiguration(String status)

  Creates a new bucket versioning configuration object with the specified status.

  Note that once versioning has been enabled for a bucket, its status can only be `suspended` and can never be set back to `off`.

  Parameters:
    `status` - The desired bucket versioning status for the new configuration object.
  See Also:
    `ENABLED`, `SUSPENDED`

Method Detail

### getStatus

    public String getStatus()

  Returns the current status of versioning for this bucket versioning configuration object, indicating if versioning is enabled or not for a bucket.

  Returns:
    The current status of versioning for this bucket versioning configuration.
  See Also:
    `OFF`, `ENABLED`, `SUSPENDED`

### setStatus

    public void setStatus(String status)

  Sets the desired status of versioning for this bucket versioning configuration object.

  Note that once versioning has been enabled for a bucket, its status can only be `suspended` and can never be set back to `off`.

  Parameters:
    `status` - The desired status of versioning for this bucket versioning configuration.
  See Also:
    `ENABLED`, `SUSPENDED`

### withStatus

    public BucketVersioningConfiguration withStatus(String status)

  Sets the desired status of versioning for this bucket versioning configuration object, and returns this object so that additional method calls may be chained together.

  Note that once versioning has been enabled for a bucket, its status can only be `suspended` and can never be set back to `off`.

  Parameters:
    `status` - The desired status of versioning for this bucket versioning configuration.
  Returns:
    The updated S3BucketVersioningConfiguration object so that additional method calls may be chained together.
  See Also:
    `ENABLED`, `SUSPENDED`

### isMfaDeleteEnabled

    public Boolean isMfaDeleteEnabled()

  Returns true if Multi-Factor Authentication (MFA) Delete is enabled for this bucket versioning configuration, false if it isn't enabled, and null if no information is available about the status of MFADelete.

  When MFA Delete is enabled, object versions can only be permanently deleted when the bucket owner passes in, as part of a delete version request, an MFA token from the hardware token generator associated with their AWS account.

  By default, MFA Delete is not enabled.

  When enabling or disabling MFA Delete controls, you must also supply an MFA token from the hardware token generator.

  Returns:
    True if the Multi-Factor Authentication (MFA) Delete is enabled for this bucket versioning configuration, false if it isn't enabled, and null if no information is present on the status of MFA Delete.

### setMfaDeleteEnabled

    public void setMfaDeleteEnabled(Boolean b)

  Sets the status of Multi-Factor Authentication (MFA) Delete for a bucket. When MFA Delete is enabled, object versions can only be permanently deleted when the bucket owner passes in, as part of a delete version request, an MFA token from the hardware token generator associated with their AWS account.

  By default, MFA Delete is not enabled.

  When enabling or disabling MFA Delete controls, you must also supply an MFA token from the hardware token generator as part of the request.

  Parameters:
    `b` - True if the Multi-Factor Authentication (MFA) Delete is being enabled enabled, false if it is being disabled.

### withMfaDeleteEnabled

    public BucketVersioningConfiguration withMfaDeleteEnabled(Boolean b)

  Sets the status of Multi-Factor Authentication (MFA) Delete for a bucket, and returns this object so that additional method calls may be chained together. When MFA Delete is enabled, object versions can only be permanently deleted when the bucket owner passes in, as part of a delete version request, an MFA token from the hardware token generator associated with their AWS account.

  By default, MFA Delete is not enabled.

  When enabling or disabling MFA Delete controls, you must also supply an MFA token from the hardware token generator as part of the request.

  Parameters:
    `b` - True if the Multi-Factor Authentication (MFA) Delete is being enabled enabled, false if it is being disabled.
  Returns:
    The updated S3BucketVersioningConfiguration object so that additional method calls may be chained together.

Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010 Amazon Web Services, Inc. All Rights Reserved.